"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CurationAndVariants(ProtocolElement):
    """
    A curation and the variants coordinates to which it corresponds
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "curation",
        "variantsCoordinates",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import cva as cva_1_5_1

        return {
            "curation": cva_1_5_1.Curation,
            "variantsCoordinates": cva_1_5_1.VariantsCoordinates,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_7 import cva as cva_1_5_1

        return {
            "org.gel.models.cva.avro.Curation": cva_1_5_1.Curation,
            "org.gel.models.cva.avro.VariantsCoordinates": cva_1_5_1.VariantsCoordinates,
            "org.gel.models.cva.avro.CurationAndVariants": cva_1_5_1.CurationAndVariants,
        }

    __slots__ = [
        "curation",
        "variantsCoordinates",
    ]

    def __init__(
        self,
        curation,
        variantsCoordinates,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_5_1.CurationAndVariants model.

        :param curation:
        :type curation: Curation
        :param variantsCoordinates:
        :type variantsCoordinates: VariantsCoordinates
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.1"
